<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'SendRequest' => '\\StructType\\SendRequest',
            'SendResponse' => '\\StructType\\SendResponse',
            'SenderIdentificationType' => '\\StructType\\SenderIdentificationType',
            'ResSenderIdentificationType' => '\\StructType\\ResSenderIdentificationType',
            'ReceiverIdentificationType' => '\\StructType\\ReceiverIdentificationType',
            'ResReceiverIdentificationType' => '\\StructType\\ResReceiverIdentificationType',
            'DataProviderType' => '\\StructType\\DataProviderType',
            'ReferenceType' => '\\StructType\\ReferenceType',
            'SignatureType' => '\\StructType\\SignatureType',
            'SignatureValueType' => '\\StructType\\SignatureValueType',
            'SignedInfoType' => '\\StructType\\SignedInfoType',
            'CanonicalizationMethodType' => '\\StructType\\CanonicalizationMethodType',
            'SignatureMethodType' => '\\StructType\\SignatureMethodType',
            'TransformsType' => '\\StructType\\TransformsType',
            'TransformType' => '\\StructType\\TransformType',
            'DigestMethodType' => '\\StructType\\DigestMethodType',
            'KeyInfoType' => '\\StructType\\KeyInfoType',
            'KeyValueType' => '\\StructType\\KeyValueType',
            'RetrievalMethodType' => '\\StructType\\RetrievalMethodType',
            'X509DataType' => '\\StructType\\X509DataType',
            'X509IssuerSerialType' => '\\StructType\\X509IssuerSerialType',
            'PGPDataType' => '\\StructType\\PGPDataType',
            'SPKIDataType' => '\\StructType\\SPKIDataType',
            'ObjectType' => '\\StructType\\ObjectType',
            'ManifestType' => '\\StructType\\ManifestType',
            'SignaturePropertiesType' => '\\StructType\\SignaturePropertiesType',
            'SignaturePropertyType' => '\\StructType\\SignaturePropertyType',
            'DSAKeyValueType' => '\\StructType\\DSAKeyValueType',
            'RSAKeyValueType' => '\\StructType\\RSAKeyValueType',
            'CDSCLAIM' => '\\StructType\\CDSCLAIM',
            'CLAIM' => '\\StructType\\CLAIM',
            'Claim-reference' => '\\StructType\\Claim_reference',
            'Attachment' => '\\StructType\\Attachment',
            'Action' => '\\StructType\\Action',
            'CDSDATA' => '\\StructType\\CDSDATA',
            'Location' => '\\StructType\\Location',
            'Data' => '\\StructType\\Data',
            'CDSIDIS' => '\\StructType\\CDSIDIS',
            'OPM' => '\\StructType\\OPM',
            'ResCap' => '\\StructType\\ResCap',
            'SysServices' => '\\StructType\\SysServices',
            'MP' => '\\StructType\\MP',
            'Price' => '\\StructType\\Price',
            'DataMO' => '\\StructType\\DataMO',
            'METER' => '\\StructType\\METER',
            'PriceMO' => '\\StructType\\PriceMO',
            'pmax_type' => '\\StructType\\Pmax_type',
            'ereact_type' => '\\StructType\\Ereact_type',
            'item_type' => '\\StructType\\Item_type',
            'TDD' => '\\StructType\\TDD',
            'TddProfile' => '\\StructType\\TddProfile',
            'TddData' => '\\StructType\\TddData',
            'MASTERDATA' => '\\StructType\\MASTERDATA',
            'Workflow' => '\\StructType\\Workflow',
            'Party' => '\\StructType\\Party',
            'Response' => '\\StructType\\Response',
            'Activity' => '\\StructType\\Activity',
            'TEMPERATURE' => '\\StructType\\TEMPERATURE',
            'Profile' => '\\StructType\\Profile',
            'CDSREQ' => '\\StructType\\CDSREQ',
            'Document' => '\\StructType\\Document',
            'Tax_Type' => '\\StructType\\Tax_Type',
            'Price_Type' => '\\StructType\\Price_Type',
            'CDSINVOICE' => '\\StructType\\CDSINVOICE',
            'DocumentEnvelope' => '\\StructType\\DocumentEnvelope',
            'DocHeader' => '\\StructType\\DocHeader',
            'PartyID' => '\\StructType\\PartyID',
            'BankAccount' => '\\StructType\\BankAccount',
            'NameAddress' => '\\StructType\\NameAddress',
            'Communication' => '\\StructType\\Communication',
            'Contact' => '\\StructType\\Contact',
            'ReferencePartyID' => '\\StructType\\ReferencePartyID',
            'DocDates' => '\\StructType\\DocDates',
            'PaymentInfo' => '\\StructType\\PaymentInfo',
            'RefDocument' => '\\StructType\\RefDocument',
            'DocDetail' => '\\StructType\\DocDetail',
            'ListOfItems' => '\\StructType\\ListOfItems',
            'Item' => '\\StructType\\Item',
            'BaseItemDetail' => '\\StructType\\BaseItemDetail',
            'PricingDetail' => '\\StructType\\PricingDetail',
            'ItemDates' => '\\StructType\\ItemDates',
            'ListOfItemsSubTotal' => '\\StructType\\ListOfItemsSubTotal',
            'ListOfPDTBlocks' => '\\StructType\\ListOfPDTBlocks',
            'PDTblock' => '\\StructType\\PDTblock',
            'Address' => '\\StructType\\Address',
            'ListOfBillingItems' => '\\StructType\\ListOfBillingItems',
            'BillingItem' => '\\StructType\\BillingItem',
            'ListOfBillingItemsSubTotal' => '\\StructType\\ListOfBillingItemsSubTotal',
            'DocSummary' => '\\StructType\\DocSummary',
            'ListOfSumItems' => '\\StructType\\ListOfSumItems',
            'SumItem' => '\\StructType\\SumItem',
            'SumItemPrice' => '\\StructType\\SumItemPrice',
            'SubTotal' => '\\StructType\\SubTotal',
            'DocumentTotal' => '\\StructType\\DocumentTotal',
            'PaymentSummary' => '\\StructType\\PaymentSummary',
            'AttachmentHeader' => '\\StructType\\AttachmentHeader',
            'AttachmentSum' => '\\StructType\\AttachmentSum',
            'CDSLDSREPORT' => '\\StructType\\CDSLDSREPORT',
            'row_type' => '\\StructType\\Row_type',
            'RESPONSE' => '\\StructType\\RESPONSE_1',
            'Reason' => '\\StructType\\Reason',
        );
    }
}
