<?php

namespace EnumType;

use \WsdlToPhp\PackageBase\AbstractStructEnumBase;

/**
 * This class stands for RETURN_CODE EnumType
 * Meta information extracted from the WSDL
 * - documentation: Element containing return code | Element obsahující return code
 * @subpackage Enumerations
 */
class RETURN_CODE extends AbstractStructEnumBase
{
    /**
     * Constant for value '0'
     * Meta information extracted from the WSDL
     * - documentation: Data přijata v pořádku | Data received
     * @return string '0'
     */
    const VALUE_0 = '0';
    /**
     * Constant for value '1'
     * Meta information extracted from the WSDL
     * - documentation: Chyba při ověření podpisu | Error during digital signature verification
     * @return string '1'
     */
    const VALUE_1 = '1';
    /**
     * Constant for value '2'
     * Meta information extracted from the WSDL
     * - documentation: Chyba při transformaci | Error during transformation
     * @return string '2'
     */
    const VALUE_2 = '2';
    /**
     * Constant for value '3'
     * Meta information extracted from the WSDL
     * - documentation: Interní chyba | Internal error
     * @return string '3'
     */
    const VALUE_3 = '3';
    /**
     * Return allowed values
     * @uses self::VALUE_0
     * @uses self::VALUE_1
     * @uses self::VALUE_2
     * @uses self::VALUE_3
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_0,
            self::VALUE_1,
            self::VALUE_2,
            self::VALUE_3,
        );
    }
}
