<?php

namespace EnumType;

use \WsdlToPhp\PackageBase\AbstractStructEnumBase;

/**
 * This class stands for voltage-level EnumType
 * Meta information extracted from the WSDL
 * - documentation: Voltage level type | Typ pro napěťovou úroveň
 * @subpackage Enumerations
 */
class Voltage_level extends AbstractStructEnumBase
{
    /**
     * Constant for value 'CV0'
     * Meta information extracted from the WSDL
     * - documentation: ostatní | others
     * @return string 'CV0'
     */
    const VALUE_CV_0 = 'CV0';
    /**
     * Constant for value 'CV1'
     * Meta information extracted from the WSDL
     * - documentation: 400 kV | 400 kV
     * @return string 'CV1'
     */
    const VALUE_CV_1 = 'CV1';
    /**
     * Constant for value 'CV2'
     * Meta information extracted from the WSDL
     * - documentation: 220 kV | 220 kV
     * @return string 'CV2'
     */
    const VALUE_CV_2 = 'CV2';
    /**
     * Constant for value 'CV3'
     * Meta information extracted from the WSDL
     * - documentation: 110 kV | 110 kV
     * @return string 'CV3'
     */
    const VALUE_CV_3 = 'CV3';
    /**
     * Constant for value 'CV4'
     * Meta information extracted from the WSDL
     * - documentation: 35 kV | 35 kV
     * @return string 'CV4'
     */
    const VALUE_CV_4 = 'CV4';
    /**
     * Constant for value 'CV5'
     * Meta information extracted from the WSDL
     * - documentation: 22 kV | 22 kV
     * @return string 'CV5'
     */
    const VALUE_CV_5 = 'CV5';
    /**
     * Constant for value 'CV6'
     * Meta information extracted from the WSDL
     * - documentation: 10 kV | 10 kV
     * @return string 'CV6'
     */
    const VALUE_CV_6 = 'CV6';
    /**
     * Constant for value 'CV7'
     * Meta information extracted from the WSDL
     * - documentation: 6 kV | 6 kV
     * @return string 'CV7'
     */
    const VALUE_CV_7 = 'CV7';
    /**
     * Constant for value 'CV8'
     * Meta information extracted from the WSDL
     * - documentation: 3 kV | 3 kV
     * @return string 'CV8'
     */
    const VALUE_CV_8 = 'CV8';
    /**
     * Constant for value 'CV9'
     * Meta information extracted from the WSDL
     * - documentation: 0,4 kV | 0,4 kV
     * @return string 'CV9'
     */
    const VALUE_CV_9 = 'CV9';
    /**
     * Return allowed values
     * @uses self::VALUE_CV_0
     * @uses self::VALUE_CV_1
     * @uses self::VALUE_CV_2
     * @uses self::VALUE_CV_3
     * @uses self::VALUE_CV_4
     * @uses self::VALUE_CV_5
     * @uses self::VALUE_CV_6
     * @uses self::VALUE_CV_7
     * @uses self::VALUE_CV_8
     * @uses self::VALUE_CV_9
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_CV_0,
            self::VALUE_CV_1,
            self::VALUE_CV_2,
            self::VALUE_CV_3,
            self::VALUE_CV_4,
            self::VALUE_CV_5,
            self::VALUE_CV_6,
            self::VALUE_CV_7,
            self::VALUE_CV_8,
            self::VALUE_CV_9,
        );
    }
}
