<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DataProviderType StructType
 * Meta information extracted from the WSDL
 * - documentation: Typ pro identifikaci poskytovatele dat
 * @subpackage Structs
 */
class DataProviderType extends AbstractStructBase
{
    /**
     * The id
     * Meta information extracted from the WSDL
     * - documentation: Data provider identification EAN13 or EIC | Identifikátor poskytovatele dat - EAN13 nebo EIC | Typ pro pseudo-EIC kód | EIC code type
     * - base: xsd:string
     * - maxLength: 16
     * - minLength: 13
     * - pattern: \c{16}
     * - use: required
     * @var string
     */
    public $id;
    /**
     * The coding_scheme
     * Meta information extracted from the WSDL
     * - use: required
     * @var string
     */
    public $coding_scheme;
    /**
     * Constructor method for DataProviderType
     * @uses DataProviderType::setId()
     * @uses DataProviderType::setCoding_scheme()
     * @param string $id
     * @param string $coding_scheme
     */
    public function __construct($id = null, $coding_scheme = null)
    {
        $this
            ->setId($id)
            ->setCoding_scheme($coding_scheme);
    }
    /**
     * Get id value
     * @return string
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set id value
     * @param string $id
     * @return \StructType\DataProviderType
     */
    public function setId($id = null)
    {
        // validation for constraint: string
        if (!is_null($id) && !is_string($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($id, true), gettype($id)), __LINE__);
        }
        // validation for constraint: maxLength(16)
        if (!is_null($id) && mb_strlen($id) > 16) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 16', mb_strlen($id)), __LINE__);
        }
        // validation for constraint: minLength(13)
        if (!is_null($id) && mb_strlen($id) < 13) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be greater than or equal to 13', mb_strlen($id)), __LINE__);
        }
        // validation for constraint: pattern(\c{16})
        if (!is_null($id) && !preg_match('/\\c{16}/', $id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression \c{16}', var_export($id, true)), __LINE__);
        }
        $this->id = $id;
        return $this;
    }
    /**
     * Get coding_scheme value
     * @return string
     */
    public function getCoding_scheme()
    {
        return $this->{'coding-scheme'};
    }
    /**
     * Set coding_scheme value
     * @param string $coding_scheme
     * @return \StructType\DataProviderType
     */
    public function setCoding_scheme($coding_scheme = null)
    {
        // validation for constraint: string
        if (!is_null($coding_scheme) && !is_string($coding_scheme)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($coding_scheme, true), gettype($coding_scheme)), __LINE__);
        }
        $this->coding_scheme = $this->{'coding-scheme'} = $coding_scheme;
        return $this;
    }
}
